<?php

namespace Drupal\layout_builder_base_library\Plugin\Layout;

/**
 * Configurable layout plugin class.
 *
 * @internal
 *   Plugin classes are internal.
 */
class BaseMultipleColumnsLayout extends BaseOneColumnLayout {

  /**
   * {@inheritdoc}
   */
  protected function isMultipleColumnsLayout() {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  protected function getColumnGapOptions() {
    return [
      'layout--column-gap--none' => 'None',
      'layout--column-gap--small' => 'Small',
      'layout--column-gap--default' => 'Default',
      'layout--column-gap--big' => 'Big',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getColumnBreakpointOptions() {
    return [
      'layout--column-breakpoint--none' => 'None',
      'layout--column-breakpoint--small' => 'Small',
      'layout--column-breakpoint--medium' => 'Medium',
      'layout--column-breakpoint--standard' => 'Standard',
      'layout--column-breakpoint--large' => 'Large',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getDefaultColumnBreakpoint() {
    return 'layout--column-breakpoint--medium';
  }
}
