<?php

namespace Drupal\layout_builder_base_library\Plugin\Layout;

use Drupal\layout_builder_base\Plugin\Layout\DefaultLayoutBase;

/**
 * Configurable layout plugin class.
 *
 * @internal
 *   Plugin classes are internal.
 */
class BaseOneColumnLayout extends DefaultLayoutBase {

  /**
   * {@inheritdoc}
   */
  protected function getBackgroundOptions() {
    return [
      'layout--background--none' => 'None',
      'layout--background--white' => 'White',
      'layout--background--grey' => 'Grey',
      'layout--background--black' => 'Black',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getBackgroundAttachmentOptions() {
    return [
      'layout--background-attachment--default' => 'Default',
      'layout--background-attachment--fixed' => 'Fixed',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getBackgroundPositionOptions() {
    return [
      'layout--background-position--default' => 'Default',
      'layout--background-position--center' => 'Center',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getBackgroundSizeOptions() {
    return [
      'layout--background-size--default' => 'Default',
      'layout--background-size--cover' => 'Cover',
      'layout--background-size--contain' => 'Contain',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getBackgroundOverlayOptions() {
    return [
      'layout--background-overlay--none' => 'None',
      'layout--background-overlay--dark' => 'Dark',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getEqualTopBottomMarginsOptions() {
    return [
      'layout--top-bottom-margin--none' => 'None',
      'layout--top-bottom-margin--small' => 'Small margins',
      'layout--top-bottom-margin--default' => 'Default margins',
      'layout--top-bottom-margin--big' => 'Big margins',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getEqualLeftRightMarginsOptions() {
    return [
      'layout--left-right-margin--none' => 'None',
      'layout--left-right-margin--small' => 'Small margins',
      'layout--left-right-margin--default' => 'Default margins',
      'layout--left-right-margin--big' => 'Big margins',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getEqualTopBottomPaddingsOptions() {
    return [
      'layout--top-bottom-padding--none' => 'None',
      'layout--top-bottom-padding--small' => 'Small paddings',
      'layout--top-bottom-padding--default' => 'Default paddings',
      'layout--top-bottom-padding--big' => 'Big paddings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getEqualLeftRightPaddingsOptions() {
    return [
      'layout--left-right-padding--none' => 'None',
      'layout--left-right-padding--small' => 'Small paddings',
      'layout--left-right-padding--default' => 'Default paddings',
      'layout--left-right-padding--big' => 'Big paddings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getContainerOptions() {
    return [
      'layout--container--default' => 'Default',
      'layout--container--none' => 'None',
      'layout--container--small' => 'Small',
      'layout--container--large' => 'Large',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function getColorsOptions() {
    return [
      'layout--color--default' => 'Default',
      'layout--color--black' => 'Black',
      'layout--color--white' => 'White',
      'layout--color--grey' => 'Grey',
    ];
  }

  /**
   * {@inheritdoc}
   */
  protected function enableImageBackground() {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  protected function getDefaultBackgroundPosition() {
    return 'layout--background-position--center';
  }

  /**
   * {@inheritdoc}
   */
  protected function getDefaultBackgroundSize() {
    return 'layout--background-size--cover';
  }

  /**
   * {@inheritdoc}
   */
  public function build(array $regions) {
    $build = parent::build($regions);
    $build['#attached']['library'][] = 'layout_builder_base_library/layout-builder-base-library';
    return $build;
  }

}
